#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/joystick.h>

int main(int argc, char *argv[])
{
struct js_event e;
char *joy_dev=0;
int fd;
int r;
fd_set readset;
struct timeval tv;
int maxx=0,maxy=0,maxz=0;
int minx=0,miny=0,minz=0;

/*
  if (argc<2)
  {
    printf("Usage: ./ptz_calibrate [options]\n");
    printf("   -j <joystick device: /dev/input/js0>\n\n");
    exit(0);
  }
*/

  /* Read in command line arguments */

  for (r=1; r<argc; r++)
  {
    if (strcmp(argv[r],"-j")==0)
    { joy_dev=argv[++r]; }
  }

  /* Open joystick /dev */

  if (joy_dev==0)
  { fd=open("/dev/input/js0",O_RDONLY); }
    else
  { fd=open(joy_dev,O_RDONLY); }

  if (fd==0)
  {
    printf("Could no open joystick device\n");
    exit(1);
  }

  /* Setup non-blocking I/O */

  fcntl(fd,F_SETFL,O_NONBLOCK);

  /* Main loop for reading the joystick device.  Use non-blocking I/O
     to ignore many joystick changes in a row. */

  while(1)
  {
    tv.tv_sec=10;
    tv.tv_usec=0;

    FD_ZERO(&readset);
    FD_SET(fd,&readset);

    if ((r=select(fd+1,&readset,NULL,NULL,&tv))==-1)
    {
      printf("Select error\n");
      break;
    }

    if (r==0) continue;

    /* read joystick events and wait for things to settle down 
       before actually sending PTZ commands.  dx,dy,dz are the
       current changed values of the joystick.  After there are
       no more joystick events queued up, send events to the camera
       based on if they are not equal to the current x,y,z. */

    while(1)
    {
      r=read(fd, &e, sizeof(struct js_event));
      if (r==-1) break;

#ifdef DEBUG
printf("number=%d value=%d\n",e.number,e.value);
#endif

      if (e.type==JS_EVENT_AXIS)
      {
        r=e.value;

        if (e.number==0)  /* Left/Right */
        {
          if (e.value<minx) minx=e.value;
            else
          if (e.value>maxx) maxx=e.value;
        }
          else
        if (e.number==1)  /* Tilt */
        {
          if (e.value<miny) miny=e.value;
            else
          if (e.value>maxy) maxy=e.value;
        }
          else
        if (e.number==3)  /* Zoom */
        {
          if (e.value<minz) minz=e.value;
            else
          if (e.value>maxz) maxz=e.value;
        }
      }
      // usleep(100);
    }


    printf("  time: %d\n",e.time);
    printf("Event-----------\n");
    printf("  time: %d\n",e.time);
    printf(" value: %d\n",e.value);
    printf("  type: %d\n",e.type);
    printf("number: %d\n\n",e.number);

    printf("     X: %d %d\n",minx,maxx);
    printf("     Y: %d %d\n",miny,maxy);
    printf("     Z: %d %d\n",minz,maxz);
  }

  close(fd);

  return 0; 
}

